// src/index.ts
import { runIfFn } from "@uspk-ui/react-utils";
import { useEffect } from "react";
import { useCallbackRef } from "@uspk-ui/react-use-callback-ref";
function useEventListener(event, handler, env, options) {
  const listener = useCallbackRef(handler);
  useEffect(() => {
    const node = runIfFn(env) ?? document;
    if (!handler) {
      return;
    }
    node.addEventListener(event, listener, options);
    return () => {
      node.removeEventListener(event, listener, options);
    };
  }, [event, env, options, listener, handler]);
  return () => {
    const node = runIfFn(env) ?? document;
    node.removeEventListener(event, listener, options);
  };
}
export {
  useEventListener
};
